package com.ruoyi.docking.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.enums.DataSourceType;
import com.ruoyi.docking.entity.ProjectProgress;
import com.ruoyi.docking.mapper.ProjectProgressMapper;
import com.ruoyi.docking.service.ProjectProgressService;
import com.ruoyi.gysl.entity.request.ZwIdPageReq;
import org.springframework.stereotype.Service;

import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.List;

/**
 * 项目月度进度（对接数据）(ProjectProgress)表服务实现类
 *
 * @author makejava
 * @since 2025-03-25 14:49:04
 */
@Service("projectProgressService")
public class ProjectProgressServiceImpl extends ServiceImpl<ProjectProgressMapper, ProjectProgress> implements ProjectProgressService {


    /**
     * 分页查询所有数据
     *
     * @param page        分页对象
     * @param zwIdPageReq 查询实体
     * @return 所有数据
     */
    @Override
    public Page<ProjectProgress> page(Page<ProjectProgress> page, ZwIdPageReq zwIdPageReq) {
        return baseMapper.page(page, zwIdPageReq);
    }

    @Override
    public List<ProjectProgress> page(ZwIdPageReq zwIdPageReq) {
        return baseMapper.page(zwIdPageReq);
    }

    /**
     * 获取项目月度信息对接数据
     */
    @DataSource(value = DataSourceType.SLAVE)
    @Override
    public List<ProjectProgress> djList() {
        //获取当前时间的上一个月的秒级时间戳
        // 获取当前时间（带时区）
        ZonedDateTime now = ZonedDateTime.now(ZoneId.systemDefault());
        // 计算上个月同一时间（自动处理跨月边界）
        ZonedDateTime lastMonth = now.minusMonths(1);
        // 上个月的时间转换为秒级时间戳
        long timestamp = lastMonth.toEpochSecond();
        // 当前的时间转换为秒级时间戳
        long nowTime = now.toEpochSecond();
        return lambdaQuery().ge(ProjectProgress::getCreatedAt, timestamp)
                .lt(ProjectProgress::getCreatedAt, nowTime).list();
    }
}

